#!/usr/bin/python
# -*- coding: UTF-8 -*-

# Ejemplo del código para el parser de XML

import sys
import os

from PyQt4.QtCore import *
from PyQt4.QtGui import *
from PyQt4.QtXml import *
from PyQt4 import QtCore, QtGui, QtXml
from xml_example import Ui_Form


class XmlExample (QWidget, Ui_Form):
	def __init__(self, parent = None):
		QWidget.__init__(self, parent)
		
		# Iniciamos la aplicación
		self.setupUi(self)
		self.connect(self.pushButton, SIGNAL("clicked()"), self.saveXmlData)
		
		# Si existiera el archivo XML, leemos los datos guardados para cargarlos en el GUI
		self.readXmlData()
		
	# Función que graba los datos al archivo XML
	def saveXmlData(self):
		
		# Agregamos los elementos del GUI hacia el XML
		self.doc = QDomDocument("XMLEXAMPLE")
		self.root = self.doc.createElement("Settings")
		self.doc.appendChild(self.root)
	
		self.tag = self.doc.createElement("Selection1")
		self.root.appendChild(self.tag)		
		self.text = self.doc.createTextNode(QVariant(self.radioButton.isChecked()).toString())
		self.tag.appendChild(self.text)
		
		self.tag = self.doc.createElement("Selection2")
		self.root.appendChild(self.tag)	
		self.text = self.doc.createTextNode(QVariant(self.radioButton_2.isChecked()).toString())
		self.tag.appendChild(self.text)
		
		self.tag = self.doc.createElement("Option1")
		self.root.appendChild(self.tag)
		self.text = self.doc.createTextNode(QVariant(self.checkBox.isChecked()).toString())
		self.tag.appendChild(self.text)
		
		self.tag = self.doc.createElement("Option2")
		self.root.appendChild(self.tag)
		self.text = self.doc.createTextNode(QVariant(self.checkBox_2.isChecked()).toString())
		self.tag.appendChild(self.text)
		
		self.tag = self.doc.createElement("LineEdit1")
		self.root.appendChild(self.tag)
		self.text = self.doc.createTextNode(self.lineEdit.text())
		self.tag.appendChild(self.text)
		
		# Abrimos el archivo, escribimos los datos y cerramos
		self.file = QtCore.QFile('example.xml')
		self.file.open(QIODevice.WriteOnly)
		self.file.write(self.doc.toString().toAscii())
		self.file.close()
		
	# Función que lee los datos almacenados en el achivo XML
	def readXmlData(self):
		
		# Variable para el contenido de los elementos
		self.yes = True
		self.no = False
		self.option1 = True
		self.option2 = False
		self.lineEditText = "text"
		
		# Abrimos el archivo XML
		self.file = QFile('example.xml')
		self.file.open(QIODevice.ReadOnly)
		
		# Cargamos el encabezado del XML y el contenido
		self.doc = QDomDocument("XMLEXAMPLE")
		self.doc.setContent(self.file)
		
		# Cerramos el archivo XML
		self.file.close()
		
		# Denominación del delemento dentro del XML
		self.docElem = self.doc.documentElement()
	
		# Comenzamos a leer el contenido del XML
		self.node = self.docElem.firstChild()
		while(self.node.isNull() == False):
			self.element = self.node.toElement() # try to convert the node to an element.
			
			if(self.element.isNull() == False):
				if(self.element.tagName().contains('Selection1')):
					self.yes = QVariant(self.element.text()).toBool()
				if(self.element.tagName().contains('Selection2')):
					self.no = QVariant(self.element.text()).toBool()
				elif(self.element.tagName().contains('Option1')):
					self.option1 = QVariant(self.element.text()).toBool()
				elif(self.element.tagName().contains('Option2')):
					self.option2 = QVariant(self.element.text()).toBool()
				elif(self.element.tagName().contains('LineEdit1')):
					self.lineEditText = self.element.text()
			self.node = self.node.nextSibling()
	
		# Opciones por defecto cargados en el GUI
		self.radioButton.setChecked(self.yes)
		self.radioButton_2.setChecked(self.no)
		self.checkBox.setChecked(self.option1)
		self.checkBox_2.setChecked(self.option2)
		self.lineEdit.setText(self.lineEditText)
		